<?php
/**********************************************************************
    Copyright (C) FrontAccounting, LLC.
	Released under the terms of the GNU General Public License, GPL, 
	as published by the Free Software Foundation, either version 3 
	of the License, or (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
    See the License here <http://www.gnu.org/licenses/gpl-3.0.html>.
***********************************************************************/
$page_security = 'SA_REP_GL_ACCOUNT_TRANSACTION';
// ----------------------------------------------------------------
// $ Revision:	2.0 $
// Creator:	Joe Hunt
// date_:	2005-05-19
// Title:	GL Accounts Transactions
// ----------------------------------------------------------------
$path_to_root="..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/admin/db/fiscalyears_db.inc");
include_once($path_to_root . "/includes/date_functions.inc");
include_once($path_to_root . "/includes/data_checks.inc");
include_once($path_to_root . "/gl/includes/gl_db.inc");

//----------------------------------------------------------------------------------------------------

print_GL_transactions();

//----------------------------------------------------------------------------------------------------

function print_GL_transactions()
{
	global $path_to_root, $systypes_array,$SysPrefs;

	$dim = get_company_pref('use_dimension');
	$dimension = $dimension2 = 0;

	$from = $_POST['PARAM_0'];
	$to = $_POST['PARAM_1'];
	$fromacc = $_POST['PARAM_2'];
	$toacc = $_POST['PARAM_3'];
	$customer = $_POST['PARAM_4'];
	$supplier = $_POST['PARAM_5'];
	if ($dim == 2)
	{
		$dimension = $_POST['PARAM_6'];
		$dimension2 = $_POST['PARAM_7'];
		$comments = $_POST['PARAM_8'];
		$show_details = $_POST['PARAM_9'];
		$orientation = $_POST['PARAM_10'];
		$destination = $_POST['PARAM_11'];
	}
	elseif ($dim == 1)
	{
		$dimension = $_POST['PARAM_6'];
		$comments = $_POST['PARAM_7'];
		$orientation = $_POST['PARAM_8'];
		$destination = $_POST['PARAM_9'];
	}
	else
	{
		$comments = $_POST['PARAM_6'];
		$orientation = $_POST['PARAM_7'];
		$destination = $_POST['PARAM_8'];
	}
	if ($destination)
		include_once($path_to_root . "/reporting/includes/excel_report.inc");
	else
		include_once($path_to_root . "/reporting/includes/pdf_report.inc");
	$orientation = ($orientation ? 'L' : 'P');

	$rep = new FrontReport(_('GL Account Transactions'), "GLAccountTransactions", user_pagesize(), 9, $orientation);
	$dec = user_price_dec();

	if ($dim == 2)
	{
		$cols = array(0, 55, 105, 125,165, 215, 270, 310, 390, 460, 510, 565);
		//------------0--1---2----3----4----5----6----7----8----9----10-------
		//------------------------dim1-dim2-----------------------------------
		$headers = array(_('Type'),	_('Ref'), _('#'),	_('Date'),	_('Cheque No'), _($SysPrefs->prefs['dim1_name']), _($SysPrefs->prefs['dim2_name']),
			_('Person/Item'), _('Debit'),	_('Credit'), _('Balance'));
	}
	elseif ($dim == 1)
	{
		$cols = array(0, 65, 105, 125, 175, 260, 260, 345, 405, 465, 525);
		//------------0--1---2----3----4----5----6----7----8----9----10-------
		//------------------------dim1----------------------------------------
		$headers = array(_('Type'),	_('Ref'), _('#'),	_('Date'), _('Dimension'), "", _('Person/Item'),
			_('Debit'),	_('Credit'), _('Balance'));
	}
	else
	{
		$cols = array(0, 65, 125, 145, 195, 195, 245, 345, 405, 465, 525);
		//------------0--1---2----3----4----5----6----7----8----9----10-------
		//--------------------------------------------------------------------
		$headers = array(_('Type'),	_('Ref'), _('#'),	_('Date'), 	_('Cheque No'), "", _('Person/Item'),
			_('Debit'),	_('Credit'), _('Balance'));
	}
	$aligns = array('left', 'left', 'left', 'left',	'left',	'left',	'left',	'left',	'right', 'right', 'right');

	if ($dim == 2)
	{
    	$params =   array( 	0 => $comments,
    				    1 => array('text' => _('Period'), 'from' => $from, 'to' => $to),
    				    2 => array('text' => _('Accounts'),'from' => $fromacc,'to' => $toacc),
                    	3 => array('text' => _('Dimension')." 1", 'from' => get_dimension_string($dimension),
                            'to' => ''),
                    	4 => array('text' => _('Dimension')." 2", 'from' => get_dimension_string($dimension2),
                            'to' => ''),
    				    5 => array('text' => _('Customer'),'from' => get_customer_name($customer)),
    				    6 => array('text' => _('Supplier'),'from' => get_supplier_name($supplier)));
    }
    elseif ($dim == 1)
    {
    	$params =   array( 	0 => $comments,
    				    1 => array('text' => _('Period'), 'from' => $from, 'to' => $to),
    				    2 => array('text' => _('Accounts'),'from' => $fromacc,'to' => $toacc),
                    	3 => array('text' => _('Dimension'), 'from' => get_dimension_string($dimension),
                            'to' => ''),
                	    4 => array('text' => _('Customer'),'from' => get_customer_name($customer)),
    				    5 => array('text' => _('Supplier'),'from' => get_supplier_name($supplier)));
    }
    else
    {
    	$params =   array( 	0 => $comments,
    				    1 => array('text' => _('Period'), 'from' => $from, 'to' => $to),
    				    2 => array('text' => _('Accounts'),'from' => $fromacc,'to' => $toacc),
    				    3 => array('text' => _('Customer'),'from' => get_customer_name($customer)),
    				    4 => array('text' => _('Supplier'),'from' => get_supplier_name($supplier)));
    }
    if ($orientation == 'L')
    	recalculate_cols($cols);

	$rep->Font();
	$rep->Info($params, $cols, $headers, $aligns);
	$rep->NewPage();

	$accounts = get_gl_accounts($fromacc, $toacc);
     $db_sum=$cr_sum=0;
	while ($account=db_fetch($accounts))
	{
		if (is_account_balancesheet($account["account_code"]))
			$begin = "";
		else
		{
			$begin = get_fiscalyear_begin_for_date($from);
			if (date1_greater_date2($begin, $from))
				$begin = $from;
			$begin = add_days($begin, -1);
		}
		$prev_balance = get_gl_balance_from_to($begin, $from, $account["account_code"], $dimension, $dimension2);

		$trans = get_gl_transactions($from, $to, -1, $account['account_code'], $dimension, $dimension2,
			null, null, null, null, null, '', $customer, $supplier);
		$rows = db_num_rows($trans);
		if ($prev_balance == 0.0 && $rows == 0)
			continue;
		$rep->Font('bold');
		$rep->TextCol(0, 4,	$account['account_code'] . " " . $account['account_name'], -2);
		$rep->TextCol(4, 6, _('Opening Balance'));
		if ($prev_balance > 0.0){
			$rep->AmountCol(7, 8, abs($prev_balance), $dec);
			$db_sum+=abs($prev_balance);
		}
		else{

			$rep->AmountCol(8, 9, abs($prev_balance), $dec);
				$cr_sum+=abs($prev_balance);
		}
		$rep->Font();
		$total = $prev_balance;
		$rep->NewLine(2);
		if ($rows > 0)
		{
			while ($myrow=db_fetch($trans))
			{
				$total += $myrow['amount'];

				$rep->TextCol(0, 1, $systypes_array[$myrow["type"]], -2);
				$reference = get_reference($myrow["type"], $myrow["type_no"]);
				$rep->TextCol(1, 2, $reference);
				$rep->TextCol(2, 3,	$myrow['type_no'], -2);
				$rep->DateCol(3, 4,	$myrow["tran_date"], true);
				$rep->TextCol(4, 5,	($myrow["cheque_no"]) ? $myrow["cheque_no"] : '-' , -2);
				
				if ($dim >= 1)
					$rep->TextCol(5, 6,	get_dimension_name($myrow['dimension_id']));
				// if ($dim > 1)
				// 	$rep->TextCol(6, 7,	get_dimension_name($myrow['dimension2_id']));
				$txt = payment_person_name($myrow["person_type_id"],$myrow["person_id"], false);
				$memo = $myrow['memo_'];
				if ($txt != "")
				{
					if ($memo != "")
						$txt = $txt." / ".$memo;
				}
				else
					$txt = $memo;
                 
                 
                 if ($destination)
                	$rep->TextCol(6, 7,	$txt);
                   else{
				$oldrow = $rep->row;
				// $rep->TextCol(6, 7,	$txt, -2);
				$rep->TextColLines(6, 7,$txt, -2);
				$newrow = $rep->row;
				$rep->row = $oldrow;
                   }

				if ($myrow['amount'] > 0.0){
					$rep->AmountCol(7, 8, abs($myrow['amount']), $dec);
						$db_sum+=abs($myrow['amount']);
				}
				else{
					$rep->AmountCol(8, 9, abs($myrow['amount']), $dec);
					$cr_sum+=abs($myrow['amount']);
				}

				$rep->TextCol(9, 10, number_format2($total, $dec));
				if ($destination)
				$rep->NewLine();
				else
				$rep->row = $newrow;

				if($show_details)
				{
					$res = get_gl_trans($myrow['type'], $myrow['type_no']);
					$ctra_acc_db=$ctra_acc_cr=array();
					while ($row = db_fetch($res)){

						if($row['account']!=$myrow["account"])
						{
							if( $row["amount"]>0)
							$ctra_acc_db[]= get_gl_account_name($row['account']).' ( '.price_format($row["amount"]).' ) ';
							else
							$ctra_acc_cr[]= get_gl_account_name($row['account']).' ( '.price_format($row["amount"]).' ) ';
						}
					} 
					// label_cell(''.implode(', ',  $ctra_acc_db).'</br>
					// '.implode(', ',  $ctra_acc_cr));
                    // $rep->NewLine();
						$oldrow = $rep->row;
						// $rep->TextCol(6, 7,	$txt, -2);
						$rep->Font('bold');
						$rep->TextColLines(0, 10,implode(', ',  $ctra_acc_db)." \n".implode(', ',  $ctra_acc_cr), -2);
						$rep->Font();
						$newrow = $rep->row;
						$rep->row = $oldrow;
						// $rep->TextCol(0, 10,	implode(', ',  $ctra_acc_db).' '.implode(', ',  $ctra_acc_cr));

					unset( $ctra_acc_db);
					unset( $ctra_acc_cr);
						$rep->row = $newrow;
						// $rep->NewLine();
				}

				if ($rep->row < $rep->bottomMargin + $rep->lineHeight)
				{
					$rep->Line($rep->row - 2);
					$rep->NewPage();
				}
			}
			$rep->NewLine();
		}
		$rep->Font('bold');
		$rep->TextCol(4, 6,	_("Total"));
	
		$rep->AmountCol(7, 8, abs($db_sum), $dec);
		$rep->AmountCol(8, 9, abs($cr_sum), $dec);
	
		$rep->NewLine();
		$rep->TextCol(4, 6,	_("Ending Balance"));
		if ($total > 0.0)
			$rep->AmountCol(9, 10, abs($total), $dec);
		else
			$rep->AmountCol(9, 10, abs($total), $dec);
		$rep->Font();
		$rep->Line($rep->row - $rep->lineHeight + 4);
		$rep->NewLine(2, 1);
	}
	$rep->End();
}

